int sensorPin = A0;    // il pin A0 è collegato al cursore di un potenziometro o all'uscita 
                       //di un sensore ad es. di temperatura, gli altri due
                       // terminali del potenziometro o sensore: uno a + 5 V , l'altro a massa 
int pwm = 13;      // seleziona il pin da cui esce il PWM
double sensorValue = 0;  // variabile in cui memorizzare la tensione in uscita dal potenziometro
double x = 0; // x us in cui il pin 13 è alto
double y = 0; // y us in cui il pin 13 è basso
void setup() {
  // dichiaro il "pwm" come uscita
  pinMode(pwm, OUTPUT);
}

   void loop() {
 
  // legge il valore di tensione proveniente dal potenziometro ( potrebbe essere la tensione 
  // fornita da un sensore ) 0V -> 0 ; 5 V -> 1023
  sensorValue = analogRead(sensorPin);
      x = 1000*(1 + sensorValue/1023); // si vuole una uscita variabile alta da 1 ms a 2 ms 
      // e frequenza 50 Hz -> T = 20 ms
      y = 10000 - x/2; // poi y viene raddoppiato
  // il "pwm" diventa alto
  digitalWrite(pwm, HIGH);  
  // alto per x us
  delayMicroseconds(x);          
  // il "pwm" diventa basso    
  digitalWrite(pwm, LOW);   
  // basso per 2*y us cioè (20000 - x)  us
  delayMicroseconds(y);
  delayMicroseconds(y);
  }

